
/*Décodage des commandes CHACON via carte Arduino
 * Christophe Caron 11/11/2017
 * www.caron.ws
*/

#define VCC_PIN 5 // Alimentation du récepteur en 5 Volt
#define GND_PIN 2 // Broche Masse du récepteur la masse du 
#define DATA_PIN 3 // Broche DATA du récepteur
 
void setup(){
 pinMode(DATA_PIN, INPUT);   // Configuration en entrée pour la sortie DATA du module
 pinMode(GND_PIN, OUTPUT);   // Configuration en sortie pour la broche GND du module
 digitalWrite(GND_PIN, LOW); // Mise à la masse la broche GND du module
 pinMode(VCC_PIN, OUTPUT);   // Configuration en sortie pour la broche VCC du module
 digitalWrite(VCC_PIN, HIGH);// Mise à VCC la broche VCC du module
 Serial.begin(115200);       // Initialisation de la liaison série
}
 
void loop()
{
 unsigned long sender = 0;
            
 if((sender = listenSignalDIO()) != 0){         // Si signale recu
        Serial.print("Code reçu: ");
        Serial.println(sender);                 // Impression du code
        }    
}
 
//listenSignalDIO()
unsigned long listenSignalDIO(){
            
        int i = 0;                          //Variable du compteur boucle
        unsigned long t = 0;                //Variable de temps entre 2 front descendant
        byte prevBit = 0;                   //avant dernière "bit" 433 reçue
        byte bit = 0;                       //dernière "bit" 433 reçue
        unsigned long sender = 0;           //code DIO au format unsigned long - ne gère pas le bit on-off, donne 2 codes différents
        t = pulseIn(DATA_PIN, LOW, 1000000);//réception des bits     
        if(t > 2550 && t < 2800) {           //on lance le déchiffrage quand on reçoit un bit correspondant au dieuxieme cadenas du signal DIO
          while(i < 64)
              {       
              t = pulseIn(DATA_PIN, LOW, 1000000);  //reception des bits        
              if(t > 280 && t < 340)                  //si environ 310 + ou - 30 c'est un bit à 0
                  {   bit = 0;              
                  }
                  else if(t > 1300 && t < 1400) //si environ 1350 + ou moins 50 c'est un bit à 1
                        {   bit = 1;                           
                        }
                        else    //sinon la série est érronnée, on sort de la fonction
                        break;
             if(i % 2 == 1) // on ne traite que les deuxièmes bits (codage manchester)
                  {
                  if((prevBit ^ bit) == 0) //si faux = codage manchester KO, on sort
                       break;
                  sender <<= 1;       //on stock chaque bit dans l'unsigned long
                  sender |= prevBit;
                  }
             prevBit = bit;  //on enregistre le bit précédent
              ++i;
            }
        }  
        if(i == 64){     // si on a 64 bit (i=64) on a un code DIO détecté
         return sender; 
        }       
     return 0; //sinon pas de code DIO
}
